/*
 * http_alias.c: Stuff for dealing with directory aliases
 * 
 * Rob McCool
 * 
 */


#include "httpd.h"

typedef struct {
    char fake[MAX_STRING_LEN];
    char real[MAX_STRING_LEN];
} alias;

static int num_a = 0;
static alias a[MAX_ALIASES];


void reset_aliases() {
    num_a = 0;
}

void add_alias(char *f, char *r) {
    strcpy(a[num_a].fake,f);

    if(r[0] != '/') 
        make_full_path(document_root,r,a[num_a++].real);
    else 
        strcpy(a[num_a++].real,r);
}

void dump_aliases() {
    register int x;

    for(x=0; x < num_a; x++)
        printf("Alias %d: %s --> %s\n",x,a[x].fake,a[x].real);
}

void translate_name(char *name) {
    register int x,l;

    getparents(name);

    for(x=0; x < num_a; x++) {
        l=strlen(a[x].fake);
        if(!strncmp(name,a[x].fake,l)) {
            strsubfirst(l,name,a[x].real);
            return;
        }
    }
    /* no alias, add document root */
    strsubfirst(0,name,document_root);
}

void unmunge_name(char *name) {
    register int x,l;

    l=strlen(document_root);
    if(!strncmp(name,document_root,l)) {
        strsubfirst(l,name,"");
        if(!name[0]) {
            name[0] = '/';
            name[1] = '\0';
        }
        return;
    }
    for(x=0;x < num_a; x++) {
        l=strlen(a[x].real);
        if(!strncmp(name,a[x].real,l)) {
            strsubfirst(l,name,a[x].fake);
            if(!name[0]) {
                name[0] = '/';
                name[1] = '\0';
            }
            return;
        }
    }
}
